routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::resource('/products', 'ProductsController', ['except' => ['show']]);

Route::resource('/orders', 'OrdersController');
Route::resource('/specialorders', 'SpecialOrdersController');

Route::resource('/customers', 'CustomersController');

Route::get('deploy', 'DeployController@index')->name('deploy.index');
Route::post('deploy', 'DeployController@execute')->name('deploy.execute');

Route::get('/summary', 'DashboardController@summary')->name('dashboard.summary');
Route::any('/', array( 'as' => 'home', 'uses' => 'DashboardController' ));

Auth::routes();

app/SpecialOrder.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class SpecialOrder extends Model
{
    public function customer()
    {
        return $this->belongsTo(User::class, 'customer_id');
    }

    public function product()
    {
        return $this->hasOne(Product::class, 'product_id');
    }
}

app/Http/Controllers/SpecialOrdersController.php
<?php

namespace App\Http\Controllers;

use App\SpecialOrder;
use App\Product;
use App\User;
use App\Slice;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Gate;
use App\Exports\OrdersExport;
use Maatwebsite\Excel\Facades\Excel;

class SpecialOrdersController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if (Gate::allows('is-Admin')) {
            return view('specialorders.index')->with('specialorders', SpecialOrder::all());
        } else {
            return view('specialorders.index')->with('specialorders', Auth::user()->specialorders);
        }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('specialorders.create')->with('products', Product::all())->with('customers', User::all());
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'form_customer' => 'bail|required',
            'form_order_date' => 'required|date'
        ]);

        $order = new Order();
        $order->customer_id = User::find($request->form_customer)->id;
        $order->order_date = Carbon::createFromFormat('m/d/Y', $request->form_order_date);
        $order->special_orders = $request->form_special_product;
        $order->estimated_price = $request->form_price;
        $order->slices_count = $request->form_quantity;
        $order->created_at = Carbon::now();
        $order->updated_at = Carbon::now();

        $order->save();

        foreach ($request->form_normal_product as $key => $value) {
            $slice = new Slice();
            $slice->product_id = $key;
            $slice->order_id = $order->id;
            $slice->quantity = $value['quantity'];
            $slice->price = $value['price'];
            $slice->save();
        }

        return redirect('orders');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\SpecialOrder  $specialOrder
     * @return \Illuminate\Http\Response
     */
    public function show(SpecialOrder $specialOrder)
    {
        return Excel::download(new OrdersExport($id), "Order" . $id . ".xlsx");
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\SpecialOrder  $specialOrder
     * @return \Illuminate\Http\Response
     */
    public function edit(SpecialOrder $specialOrder)
    {
        $order = Order::find($id);
        $slices = Slice::where('order_id', $id)->get();
        return view('orders.edit')->with('order', $order)->with('slices', $slices);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\SpecialOrder  $specialOrder
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, SpecialOrder $specialOrder)
    {
        $order = Order::find($id);
        $order->special_orders = $request->form_special_product;
        $order->estimated_price = $request->form_price;
        $order->slices_count = $request->form_quantity;
        $order->updated_at = Carbon::now();
        $order->save();

        foreach ($request->form_normal_product as $key => $value) {
            $slice = Slice::where([
                ['order_id', '=', $order->id],
                ['product_id', '=', $key],
            ])->first();
            $slice->quantity = $value['quantity'];
            $slice->save();
        }

        return redirect('orders');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\SpecialOrder  $specialOrder
     * @return \Illuminate\Http\Response
     */
    public function destroy(SpecialOrder $specialOrder)
    {
        Product::destroy($name);

        return redirect()->back();
    }
}

resources/views/specialorders/create.blade.php
@extends('layouts.app')

@section('content-header')
<!-- Content Header (Page header) -->
<section class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1>Special Order - Create</h1>
            </div>
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    <li class="breadcrumb-item"><a href="#">Home</a></li>
                    <li class="breadcrumb-item active">Special Orders</li>
                </ol>
            </div>
        </div>
    </div>
    <!-- /.container-fluid -->
</section>
@endsection

@section('content')
<!-- Main content -->
<section class="content">
    <div class="row">
        <div class="col-12">
            <div class="card">

                <div class="card-header">
                    <h3 class="card-title">New Order</h3>

                    <div class="card-tools">
                        <!-- Buttons, labels, and many other things can be placed here! -->
                        <!-- Here is a label for example -->
                    </div>

                </div>

                <div class="card-body">

                    <form id="createOrderForm" action="{{action('SpecialOrdersController@store')}}" method="POST">
                        @csrf

                        <div class="row">
                            {{-- Column A --}}
                            {{-- Customer Name and DatePicker --}}
                            <div class="col-sm-6">
                                @if ($errors->any())
                                <div class="alert alert-danger">
                                    <ul>
                                        @foreach ($errors->all() as $error)
                                        <li>{{ $error }}</li>
                                        @endforeach
                                    </ul>
                                </div>
                                @endif
                                <label for="inlineFormInput">Customer:</label>
                                <div class="form-group">
                                    @can('is-Admin')
                                    <select class="form-control customers-single">
                                        @foreach ($customers as $customer)
                                        <option value={{$customer->id}}>{{$customer->name}}</option>
                                        @endforeach
                                        <option value={{ Auth::user()->id }} selected>{{ Auth::user()->name }}</option>
                                    </select>
                                    @else
                                    <input type="text" class="form-control mb-2" name="name"
                                        placeholder="{{ Auth::user()->name }}" disabled="disabled">
                                    <input type="hidden" class="form-control mb-2" name="form_customer"
                                        value="{{ Auth::user()->id }}">
                                    @endcan
                                </div>

                                <label>Date range:</label>

                                <div class="form-group">
                                    <div class="input-group">
                                        <div class="input-group-prepend">
                                            <span class="input-group-text">
                                                <i class="far fa-calendar-alt"></i>
                                            </span>
                                        </div>
                                        <input type="text" class="form-control float-right" id="orderDate"
                                            name="form_order_date">
                                    </div>
                                    <!-- /.input group -->
                                </div>


                                <label>Extra Info:</label>
                                <div class="mb-3">
                                    <textarea class="textarea" placeholder="Place some text here"
                                        name="form_special_product"
                                        style="width: 100%; height: 80px; font-size: 14px; line-height: 18px; border: 1px solid #dddddd; padding: 10px;"></textarea>
                                </div>
                            </div>

                            {{-- Column B --}}
                            {{-- Product and Picture --}}
                            <div class="col-sm-6">
                                <label for="form_product"> Product:</label>
                                <div class="form-group">
                                    <select class="form-control cakes-with-pictures-single">
                                        @foreach ($products as $product)
                                        <option value={{$product->thumbnail}}>{{$product->name}}</option>
                                        @endforeach
                                    </select>
                                </div>

                                {{-- <div class="form-group">
                                    <img class="img-thumbnail" src="../storage/product_thumbnails/barackos-turo.png"
                                        width="200" height="200">
                                </div> --}}

                                <div class="form-group">
                                    <label for="thumbnailFile">Upload thumbnail</label>
                                    <div class="input-group">
                                        <!-- https://github.com/Johann-S/bs-custom-file-input -->
                                        <div class="custom-file">
                                            <label class="custom-file-label" for="thumbnailFile">Choose file</label>
                                            <input type="file" class="form-control" id="thumbnailFile"
                                                name="thumbnailFile" accept=".jpg,.jpeg">
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
                {{-- CardBody --}}

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary" form="createOrderForm">Submit</button>
                </div>

            </div>
            {{-- card --}}

        </div>
    </div>
</section>

@endsection

@section('customjs')
<script>
    function formatState(state) {
        if (!state.id) {
            return state.text;
        }
        var $state = $(
            '<span><img src="../storage/' + state.id + '" class="img-flag" width="50" height="50"/> ' + state.text + '</span>'
        );
        return $state;
    };

    $(document).ready(function() {
        $('.cakes-with-pictures-single').select2({
            templateResult: formatState,
            debug: 'true'
        });

        $('.customers-single').select2({
            debug: 'true'
        });

        //Date range picker with time picker
        $('#orderDate').daterangepicker({
            timePicker: false, //<==MAKE THE CHANGE HERE
            singleDatePicker: true, //<==MAKE THE CHANGE HERE
        });

        $('.cakes-with-pictures-single').on('select2:select', function (e) {
            $('.img-thumbnail').attr("src", "../storage/" + e.params.data.id);
        });
    });
</script>
@endsection

resources/views/specialorders/edit.blade.php
@extends('layouts.app')

@section('content-header')
<!-- Content Header (Page header) -->
<section class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1>Order - Create</h1>
            </div>
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    <li class="breadcrumb-item"><a href="#">Home</a></li>
                    <li class="breadcrumb-item active">Orders</li>
                </ol>
            </div>
        </div>
    </div>
    <!-- /.container-fluid -->
</section>
@endsection

@section('content')
<!-- Main content -->
<section class="content">
    <div class="row">
        <div class="col-12">
            <div class="card">

                <div class="card-header">
                    <h3 class="card-title">Edit Order</h3>

                    <div class="card-tools">
                        <!-- Buttons, labels, and many other things can be placed here! -->
                        <!-- Here is a label for example -->
                    </div>

                </div>

                <div class="card-body">

                    <form id="updateOrderForm" role="form" action="{{ route('orders.update', $order->id)}}" method="POST">
                        @method('PUT')
                        @csrf

                        <div class="form-row align-items-center">

                            <div class="col-4">
                                @if ($errors->any())
                                <div class="alert alert-danger">
                                    <ul>
                                        @foreach ($errors->all() as $error)
                                        <li>{{ $error }}</li>
                                        @endforeach
                                    </ul>
                                </div>
                                @endif
                                <div class="form-group">
                                    <label for="inlineFormInput">Customer:</label>
                                    <input type="text" class="form-control mb-2" name="name"
                                        placeholder="{{ $order->customer->name }}" disabled="disabled">
                                    <input type="hidden" class="form-control mb-2" name="orderID"
                                        value="{{ $order->id }}">
                                </div>

                                <label>Date range:</label>

                                <div class="form-group">
                                    <div class="input-group">
                                        <div class="input-group-prepend">
                                            <span class="input-group-text">
                                                <i class="far fa-calendar-alt"></i>
                                            </span>
                                        </div>
                                        <input type="text" class="form-control float-right" id="orderDate"
                                            name="form_order_date" disabled="disabled">
                                    </div>
                                    <!-- /.input group -->
                                </div>
                            </div>
                            {{-- This separates the items from above. Separator. Dont remove --}}
                            <div class="col-4">
                                <input type="hidden" name="form_price" id="form_price">
                                <input type="hidden" name="form_quantity" id="form_quantity">
                            </div>
                            <div class="col-4">
                                <div class="small-box bg-info">
                                    <div class="inner">
                                        <h3 id="pricetag">0 HUF (0 Slices)</h3>
                                        <p>Calculated Price</p>
                                    </div>
                                    <div class="icon">
                                        <i class="fas fa-shopping-cart"></i>
                                    </div>
                                    <a href="#" class="small-box-footer">
                                        More info <i class="fas fa-arrow-circle-right"></i>
                                    </a>
                                </div>
                            </div>
                            @foreach ($slices as $slice)
                            <div class="col-4">
                                <div class="input-group mb-2">
                                    <div class="input-group-prepend">
                                        <div class="input-group-text">{{$slice->product->name}}</div>
                                    </div>
                                    <input type="number" class="form-control"
                                        name="form_normal_product[{{$slice->product_id}}][quantity]" value={{$slice->quantity}}
                                        onchange="calcPrice()">
                                    <input type="number" class="form-control"
                                        name="form_normal_product[{{$slice->product_id}}][price]" value={{$slice->price}}
                                        hidden>
                                    <div class="input-group-append">
                                        <span class="input-group-text">{{$slice->price}} HUF/db</span>
                                    </div>
                                </div>
                            </div>
                            @endforeach
                        </div>
                        <hr>
                        <h2>Special Orders:</h2>
                        <div class="mb-3">
                            <textarea class="textarea" name="form_special_product"
                                style="width: 100%; height: 200px; font-size: 14px; line-height: 18px; border: 1px solid #dddddd; padding: 10px;">
                                {{$order->special_orders}}
                            </textarea>
                        </div>
                    </form>
                </div>
                {{-- CardBody --}}

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary" form="updateOrderForm">Save</button>
                </div>

            </div>
            {{-- card --}}

        </div>
    </div>
</section>

@endsection

@section('customjs')
<script>
    $(function(){
        //Date range picker with time picker
        $('#orderDate').daterangepicker({
        timePicker: false, //<==MAKE THE CHANGE HERE
        singleDatePicker: true, //<==MAKE THE CHANGE HERE
        });

        // Summernote
        $('.textarea').summernote();

        calcPrice();
    });

    function calcPrice()
    {
        var total = 0;
        var quantity = 0;

        @foreach ($slices as $slice)
            total += parseInt(document.getElementsByName("form_normal_product[{{$slice->product_id}}][quantity]")[0].value) * 
            document.getElementsByName("form_normal_product[{{$slice->product_id}}][price]")[0].value;

            quantity += parseInt(document.getElementsByName("form_normal_product[{{$slice->product_id}}][quantity]")[0].value);
        @endforeach
        
        document.getElementById("pricetag").innerText = total + " HUF (" + quantity + " slices)";
        document.getElementById("form_price").value = total;
        document.getElementById("form_quantity").value = quantity;
    }
</script>
@endsection

resources/views/specialorders/index.blade.php
@extends('layouts.app')

@section('customcss')
<!-- DataTables -->
<link rel="stylesheet" href="{{ asset('AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.css') }}">
@endsection

@section('content-header')
<!-- Content Header (Page header) -->
<section class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1>Special Orders</h1>
            </div>
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    <li class="breadcrumb-item"><a href="#">Home</a></li>
                    <li class="breadcrumb-item active">Special Orders</li>
                </ol>
            </div>
        </div>
    </div>
    <!-- /.container-fluid -->
</section>
@endsection

@section('content')
<!-- Main content -->
<section class="content">
    <div class="row">
        <div class="col-12">
            <div class="card">

                <div class="card-header">
                    <h3 class="card-title">DataTable</h3>

                    <div class="card-tools">
                        <!-- Buttons, labels, and many other things can be placed here! -->
                        <!-- Here is a label for example -->
                        <a href="{{route('specialorders.create')}}" type="button" class="btn btn-tool">
                            <i class="fas fa-plus-circle"></i>
                        </a>
                    </div>

                </div>

                <div class="card-body">
                    <div id="specialOrdersDataTable" class="dataTables_wrapper dt-bootstrap4">
                        <div class="row">
                            <div class="col-sm-12 col-md-6"></div>
                            <div class="col-sm-12 col-md-6"></div>
                        </div>
                        <div class="row">
                            <div class="col-sm-12">
                                <table class="table table-bordered table-hover dataTable table-sm" role="grid"
                                    id="specialOrdersTable">
                                    <thead>
                                        <tr>
                                            <th class="sorting_asc" tabindex="0" rowspan="1" colspan="1">Date</th>
                                            <th class="sorting" tabindex="0" rowspan="1" colspan="1">Customer</th>
                                            <th class="sorting" tabindex="0" rowspan="1" colspan="1">Product</th>
                                            <th colspan="1">Actions</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach ($specialorders as $specialorder)
                                        <tr role="row">
                                            <td>{{$specialorder->order_date->format('D d/m/Y')}}</td>
                                            <td>{{$specialorder->customer->name}}</td>
                                            <td>{{$specialorder->product->name}}</td>
                                            <td>
                                                <a href="{{ route('specialorders.edit', $specialorder->id)}}"
                                                    class="btn btn-primary btn-sm">
                                                    <i class="fas fa-edit"></i>
                                                </a>

                                                <button class="btn btn-danger btn-sm" type="submit" form="deleteForm"
                                                    formaction="{{ route('specialorders.destroy', $specialorder->id)}}">
                                                    <i class="far fa-minus-square"></i>
                                                </button>

                                                <a href="{{ route('specialorders.show', $specialorder->id)}}"
                                                    class="btn btn-primary btn-sm">
                                                    <i class="fas fa-download"></i>
                                                </a>
                                            </td>
                                        </tr>
                                        @endforeach
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                    {{-- ordersDataTable --}}

                </div>
                {{-- CardBody --}}

            </div>
            {{-- card --}}

        </div>
    </div>
</section>

@endsection

@section('customjs')

<script src="{{ asset('AdminLTE/plugins/datatables/jquery.dataTables.js')}}"></script>
<script src=" {{ asset('AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.js')}}"></script>

<script>
    $(document).ready(function() {
        $('#specialOrdersTable').DataTable();
    });
</script>

@endsection